[BACK]Return to mktemp.1 CVS log [TXT][DIR] Up to [local] / src / usr.bin / mktemp

File: [local] / src / usr.bin / mktemp / mktemp.1 (download)

Revision 1.20, Thu Oct 11 00:05:55 2001 UTC (22 years, 7 months ago) by millert
Branch: MAIN
CVS Tags: OPENBSD_3_3_BASE, OPENBSD_3_3, OPENBSD_3_2_BASE, OPENBSD_3_2, OPENBSD_3_1_BASE, OPENBSD_3_1, OPENBSD_3_0_BASE, OPENBSD_3_0
Changes since 1.19: +43 -27 lines

Sync with portable mktemp-1.4; the template is now optional.
Came out of discussions with Solar Designer.

.\"	$OpenBSD: mktemp.1,v 1.20 2001/10/11 00:05:55 millert Exp $
.\"
.\" Copyright (c) 1996, 2000, 2001 Todd C. Miller <Todd.Miller@courtesan.com>
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
.\" AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
.\" THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
.\" EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
.\" PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
.\" OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
.\" WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
.\" OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
.\" ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 30, 2001
.Dt MKTEMP 1
.Os
.Sh NAME
.Nm mktemp
.Nd make temporary filename (unique)
.Sh SYNOPSIS
.Nm mktemp
.Op Fl dqtu
.Op Fl p Ar directory
.Op Ar template
.Sh DESCRIPTION
The
.Nm mktemp
utility takes the given filename
.Ar template
and overwrites a portion of it to create a unique filename.
The
.Ar template
may be any filename with some number of
.Ql X Ns s
appended
to it, for example
.Pa /tmp/tfile.XXXXXXXXXX .
If no
.Ar template
is specified a default of
.Pa tmp.XXXXXXXXXX
is used and the
.Fl t
flag is implied (see below).
.Pp
The trailing
.Ql X Ns s
are replaced with a combination of the current process number and
random letters.
The name chosen depends both on the number of
.Ql X Ns s
in the
.Ar template
and the number of collisions with pre-existing files.
The number of unique filenames
.Nm
can return depends on the number of
.Ql X Ns s
provided; ten
.Ql X Ns s
will
result in
.Nm
testing roughly 26 ** 10 combinations.
.Pp
If
.Nm
can successfully generate a unique filename, the file (or directory)
is created with file permissions such that it is only readable and writable
by its owner (unless the
.Fl u
flag is given) and the filename is printed to standard output.
.Pp
.Nm mktemp
is provided to allow shell scripts to safely use temporary files.
Traditionally, many shell scripts take the name of the program with
the PID as a suffix and use that as a temporary filename.
This kind of naming scheme is predictable and the race condition it creates
is easy for an attacker to win.
A safer, though still inferior approach
is to make a temporary directory using the same naming scheme.
While this does allow one to guarantee that a temporary file will not be
subverted, it still allows a simple denial of service attack.
For these reasons it is suggested that
.Nm
be used instead.
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl d
Make a directory instead of a file.
.It Fl p Ar directory
Use the specified
.Ar directory
as a prefix when generating the temporary filename.
The
.Ar directory
will be overridden by the user's
.Ev TMPDIR
environment variable if it is set.
This option implies the
.Fl t
flag (see below).
.It Fl q
Fail silently if an error occurs.
This is useful if
a script does not want error output to go to standard error.
.It Fl t
Generate a path rooted in a temporary directory.
This directory is chosen as follows:
.Bl -bullet
.It
If the user's
.Ev TMPDIR
environment variable is set, the directory contained therein is used.
.It
Otherwise, if the
.Fl p
flag was given the specified directory is used.
.It
If none of the above apply,
.Pa /tmp
is used.
.El
.Pp
In this mode, the
.Ar template
(if specified) should be a directory component (as opposed to a full path)
and thus should not contain any forward slashes.
.It Fl u
Operate in
.Dq unsafe
mode.
The temp file will be unlinked before
.Nm
exits.
This is slightly better than
.Fn mktemp 3
but still introduces a race condition.
Use of this option is not encouraged.
.El
.Pp
The
.Nm
utility
exits with a value of 0 on success or 1 on failure.
.Sh EXAMPLES
The following
.Xr sh 1
fragment illustrates a simple use of
.Nm
where the script should quit if it cannot get a safe
temporary file.
.Bd -literal -offset indent
TMPFILE=`mktemp /tmp/example.XXXXXXXXXX` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
The same fragment with support for a user's
.Ev TMPDIR
environment variable can be written as follows.
.Bd -literal -offset indent
TMPFILE=`mktemp -t example.XXXXXXXXXX` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
This can be further simplified if we don't care about the actual name of
the temporary file.  In this case the
.Fl t
flag is implied.
.Bd -literal -offset indent
TMPFILE=`mktemp` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
In some cases, it may be desirable to use a default temporary directory
other than
.Pa /tmp .
In this example the temporary file will be created in
.Pa /extra/tmp
unless the user's
.Ev TMPDIR
environment variable specifies otherwise.
.Bd -literal -offset indent
TMPFILE=`mktemp -p /extra/tmp example.XXXXXXXXXX` || exit 1
echo "program output" >> $TMPFILE
.Ed
.Pp
In some cases, we want the script to catch the error.
For instance, if we attempt to create two temporary files and
the second one fails we need to remove the first before exiting.
.Bd -literal -offset indent
TMP1=`mktemp -t example.1.XXXXXXXXXX` || exit 1
TMP2=`mktemp -t example.2.XXXXXXXXXX`
if [ $? -ne 0 ]; then
	rm -f $TMP1
	exit 1
fi
.Ed
.Pp
Or perhaps you don't want to exit if
.Nm
is unable to create the file.
In this case you can protect that part of the script thusly.
.Bd -literal -offset indent
TMPFILE=`mktemp -q -t example.XXXXXXXXXX` && {
	# Safe to use $TMPFILE in this block
	echo data > $TMPFILE
	...
	rm -f $TMPFILE
}
.Ed
.Sh ENVIRONMENT
.Bl -tag -width TMPDIR
.It Ev TMPDIR
directory in which to place the temporary file when in
.Fl t
mode
.El
.Sh SEE ALSO
.Xr mkdtemp 3 ,
.Xr mkstemp 3 ,
.Xr mktemp 3
.Sh HISTORY
The
.Nm
utility appeared in
.Ox 2.1 .